// $KyokoNet: antifetch, v 0.1.5 2022/11/13 10:43:10 akoizumi Exp $
//
// Get current system information like neofetch(1) without fancy things.
// It mostly uses the standard library, and an extra dependency.
package main

import (
	"fmt"
	"os"
	"log"
	"runtime"
	"github.com/shirou/gopsutil/host"
)

func main() {
	hostname, err := os.Hostname()
	uptime, _ := host.Uptime()

	days := uptime / (60 * 60 * 24)
	hours := (uptime - (days * 60 * 60 * 24)) / (60 * 60)
	minutes := ((uptime - (days * 60 * 60 * 24))  -  (hours * 60 * 60)) / 60

	if err != nil {
		log.Fatal(err)
	}
	
	fmt.Printf("%s (%d) @ %s", os.Getenv("USER"), os.Getuid(), hostname)
	fmt.Printf("\n")
	fmt.Printf("Editor: %s\n", os.Getenv("EDITOR"))
	fmt.Printf("Operating System: %s\n", runtime.GOOS)
	fmt.Printf("Architecture: %s\n", runtime.GOARCH)
	fmt.Printf("Shell: %s\n", os.Getenv("SHELL"))
	fmt.Printf("Uptime: %d days, %d hours, %d minutes\n", days, hours, minutes)
}
